## isospec 2.2.3+cleaned1

=== CMakeLists.txt ===
#############################################################
#############################################################
# CMake configuration

cmake_minimum_required(VERSION 3.12)

# CMake script for the IsoSpec library
# Author: Anonymous and Filippo Rusconi
# This script was present in the source tree but was
# highly rudimentary. I have implemented most of what is
# here (Filippo Rusconi).
# Last Modifs: July 2020

############################################################
############################################################
# Basic information about project

project(IsoSpec
    DESCRIPTION "A program to calculate isotopic clusters"
    HOMEPAGE_URL "https://github.com/MatteoLacki/IsoSpec")

set(ISOSPEC_VERSION_MAJOR "2")
set(ISOSPEC_VERSION_MINOR "2")
set(ISOSPEC_VERSION_PATCH "3")
set(ISOSPEC_LIB_NAME "libIsoSpec++")
set(ISOSPEC_VERSION "${ISOSPEC_VERSION_MAJOR}.${ISOSPEC_VERSION_MINOR}.${ISOSPEC_VERSION_PATCH}")
set(VERSION 2.2.3)
set(ISOSPEC_LIB_VERSION ${ISOSPEC_VERSION})
set(ISOSPEC_LIB_SOVERSION ${ISOSPEC_VERSION_MAJOR})

# Command to enable debug mode
# cmake -DCMAKE_BUILD_TYPE=Debug 


# This setting is also typically overridden by 
# configuring the build system like this:
# cmake -DCMAKE_INSTALL_PREFIX=/usr
# It needs to be set before include(GNUInstallDirs)
# below, because it roots all the other dirs' configs.

if(NOT CMAKE_INSTALL_PREFIX)
    set(CMAKE_INSTALL_PREFIX /usr)
endif()

# This module sets a number of installation directories 
# according to the GNU coding standards. It takes the
# CMAKE_INSTALL_PREFIX and then add the directories to it.
include(GNUInstallDirs)

# Add folder where are supportive functions
# that contain toolchains: for UNIX/WIN/MAC
# that contain modules useful on any system.
set(CMAKE_UTILS_PATH ${CMAKE_SOURCE_DIR}/CMakeStuff)
set(CMAKE_TOOLCHAINS_PATH ${CMAKE_UTILS_PATH}/toolchains)
set(CMAKE_MODULE_PATH ${CMAKE_UTILS_PATH}/modules)
#message("CMAKE_MODULE_PATH:" ${CMAKE_MODULE_PATH})

# This says that when compiling, .h files must also be
# searche in the current directory where cpp files are 
# compiled.
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Include the system's uname that fills in SYSTEM_UNAME_S.
# Sets WIN64 if SYSTEM_UNAME_S is "^.*MING64.*"
include(${CMAKE_UTILS_PATH}/systemUname.cmake)

# Include the various colors we want to use in the output
include(${CMAKE_UTILS_PATH}/outputColors.cmake)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

message("")
message("\n${BoldRed}Configuring build for project ${PROJECT_NAME}${ColourReset}\n")
message("")

# This export will allow using the flags to be used by
# youcompleteme (vim plugin).
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json" )
    execute_process( COMMAND cmake -E copy_if_different
        ${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json
        ${CMAKE_CURRENT_SOURCE_DIR}/compile_commands.json
        )
endif()


# We want C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "${BoldGreen}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

#############################################################
# We do not want warnings for unknown pragmas:
message(STATUS "${BoldGreen}Setting definition -Wno-unknown-pragmas.${ColourReset}")
add_definitions(-Wno-unknown-pragmas)

# Enable warnings and possibly treat them as errors
message(STATUS "${BoldGreen}Setting definition -Wall.${ColourReset}")
add_definitions(-Wall)
message(STATUS "${BoldGreen}Setting definition -Wextra.${ColourReset}")
add_definitions(-Wextra)
message(STATUS "${BoldGreen}Setting definition -pedantic.${ColourReset}")
add_definitions(-pedantic)

if(WARN_AS_ERROR)
    message(STATUS "${BoldYellow}Setting definition -Werror.${ColourReset}")
    add_definitions(-Werror)
endif()

message(STATUS "${BoldGreen}CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}${ColourReset}")
message(STATUS "${BoldGreen}CMAKE_BINARY_DIR: ${CMAKE_BINARY_DIR}${ColourReset}")


#############################################################
#############################################################
# Platform-specific CMake configuration

# MXE is a pretty cool cross-compilation environment that allows one
# to build Win software right into GNU/Linux.
if(MXE)

    include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)
    #include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain-olivier.cmake)

    # Set the name to the systemUname variable because in this situation that name
    # is not found, it it passed as a flag in the command line.
    set(SYSTEM_UNAME_S "mxe")

elseif(UNIX AND NOT APPLE)

    include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain.cmake)

elseif(WIN32 OR _WIN32)

    if(WIN10MINGW64)
        include(${CMAKE_TOOLCHAINS_PATH}/win10-mingw64-toolchain.cmake)
    endif()

elseif(APPLE)

    include(${CMAKE_TOOLCHAINS_PATH}/apple-macport-toolchain.cmake)

endif()

message("")
message("${BoldRed}The build toolchain is: ${SYSTEM_UNAME_S}${ColourReset}")
message("")


#############################################################
#############################################################
# Essential software configuration

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
        "Type of build, options are: None, Debug, Release, RelWithDebInfo, MinSizeRel."
        FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE MATCHES "Release")
    #message(STATUS "Compiling in release mode.")
    add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

if(CMAKE_BUILD_TYPE MATCHES "Debug")
    #message(STATUS "Compiling in debug mode.")
    message(STATUS "Add definition -ggdb3 to format debug output for GDB.")
    add_definitions(-ggdb3)
endif()

if(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
    #message(STATUS "Compiling in release with debug info mode.")
endif(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")

message(STATUS "${BoldYellow}CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}.${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}.${ColourReset}")


# message(STATUS CMAKE_MODULE_PATH: ${CMAKE_MODULE_PATH})

# Now actually deal with the C++ source code.
add_subdirectory(IsoSpec++)

=== IsoSpec++/Makefile ===
OPTFLAGS=-O3 -march=native -mtune=native
DEBUGFLAGS=-O0 -g -Werror -DISOSPEC_DEBUG -DDEBUG -D_GLIBCXX_DEBUG
CXXFLAGS=-std=c++11 -Wall -pedantic -Wextra -Wshadow -Wcast-align -Wcast-qual -Wctor-dtor-privacy -Wdisabled-optimization -Wformat=2 -Winit-self -Wmissing-include-dirs -Wno-old-style-cast -Woverloaded-virtual -Wredundant-decls -Wshadow -Wno-sign-conversion -Wsign-promo -Wswitch-default -Wundef
SRCFILES=cwrapper.cpp allocator.cpp  dirtyAllocator.cpp  isoSpec++.cpp  isoMath.cpp  marginalTrek++.cpp  operators.cpp element_tables.cpp misc.cpp mman.cpp fixedEnvelopes.cpp fasta.cpp

all: unitylib

unitylib:
	$(CXX) $(CXXFLAGS) $(OPTFLAGS) unity-build.cpp -fPIC -shared -o libIsoSpec++.so

debug:
	$(CXX) $(CXXFLAGS) $(DEBUGFLAGS) unity-build.cpp -DDEBUG -fPIC -shared -o libIsoSpec++.so

debug-gcc:
	g++ $(CXXFLAGS) $(DEBUGFLAGS) unity-build.cpp -DDEBUG -fPIC -shared -o libIsoSpec++.so

nonunity:
	$(CXX) $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) -DDEBUG -fPIC -shared -o libIsoSpec++.so

clean:
	rm -f libIsoSpec++.so

windows:
	#g++ -O3 -std=gnu++1z -O3 -shared -static -static-libstdc++ -static-libgcc unity-build.cpp -o ../IsoSpecPy/IsoSpec++.dll
	x86_64-w64-mingw32-g++.exe -std=c++11 -O3 -shared -static -static-libstdc++ unity-build.cpp -o ../IsoSpecPy/IsoSpecPy/prebuilt-libIsoSpec++-2.1.0-x64.dll
	i686-w64-mingw32-g++.exe -std=c++11 -O3 -shared -static -static-libstdc++ unity-build.cpp -o ../IsoSpecPy/IsoSpecPy/prebuilt-libIsoSpec++-2.1.0-x32.dll
check:
	cpplint *.cpp *.h
	#cppcheck --std=c++11 --language=c++ --enable=style,portability,missingInclude,performance -q --force *.cpp *.h --suppress=memleakOnRealloc:*:* --inline-suppr --template={file}:{line}\ \({severity}\)\ \<{id}\>:\ {message}

check11:
	$(CXX) -std=c++11 -Wall -pedantic -Wextra -Wshadow -fsyntax-only unity-build.cpp

asm:
	$(CXX) $(CXXFLAGS) $(OPTFLAGS) unity-build.cpp -S -o out.S

=== man/CMakeLists.txt ===

message("")
message(STATUS "${BoldGreen}Starting configuration for the doc material for ${PROJECT_NAME} ${ColourReset}")
message("")

# Prepare the logo picture files with the right version (configure_file)

configure_file(${CMAKE_SOURCE_DIR}/CMakeStuff/isospec_logo2_high.svg.in
	${CMAKE_CURRENT_SOURCE_DIR}/images/isospec_logo2_high_versioned.svg @ONLY)

configure_file(${CMAKE_SOURCE_DIR}/CMakeStuff/isospec_logo2_long.svg.in
	${CMAKE_CURRENT_SOURCE_DIR}/images/isospec_logo2_long_versioned.svg @ONLY)

# Make the conversion of the svg file into a png, but only on GNU/Linux
# Produce a file with respected aspect ratio, 200 pixels wide.

if(UNIX AND NOT APPLE)
	execute_process(COMMAND gm convert -geometry 200x
		${CMAKE_CURRENT_SOURCE_DIR}/images/isospec_logo2_high_versioned.svg
		${CMAKE_CURRENT_SOURCE_DIR}/images/isospec_logo2_high_versioned.png)
endif()


if(UNIX AND NOT APPLE)
	execute_process(COMMAND gm convert -geometry 200x
		${CMAKE_CURRENT_SOURCE_DIR}/images/isospec_logo2_long_versioned.svg
		${CMAKE_CURRENT_SOURCE_DIR}/images/isospec_logo2_long_versioned.png)
endif()

# Ensure that the doxyfile configuration file for Doxygen has always
# the proper version number!

configure_file(${CMAKE_SOURCE_DIR}/CMakeStuff/doxyfile.in
	${CMAKE_CURRENT_SOURCE_DIR}/doxyfile @ONLY)

add_custom_target(html_doc
	COMMAND doxygen doxyfile 
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
	COMMENT "Doxygen-based developer html documentation generation")

add_custom_target(pdf_doc
	COMMAND make
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/latex
	COMMENT "Doxygen-based developer pdf documentation generation")


###############
# install stuff

install(DIRECTORY images
	DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/doc/isospec)

install(DIRECTORY html 
	DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/doc/isospec)

install(FILES latex/refman.pdf
	DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/doc/isospec/pdf)

file(GLOB man3_pages "man/man3/*")

install(FILES ${man3_pages}
	DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man3)

message("")
message(STATUS "${BoldGreen}Finished configuration of the doc material.${ColourReset}")
message("")

=== debian/changelog ===
isospec (2.2.3+cleaned1-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version: 4.7.2

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 16 Oct 2025 11:52:51 +0200

=== debian/control ===
Source: isospec
Section: science
Priority: optional
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
 dh-exec,
 graphicsmagick-imagemagick-compat,
 cmake,
 d-shlibs,
 dh-python,
 python3-dev,
 python3-setuptools,
 python3-cffi,
 texlive-latex-base,
 texlive-latex-recommended,
 texlive-latex-extra,
 texlive-plain-generic,
 texlive-fonts-recommended,
 texlive-font-utils,
 ghostscript,
 doxygen,
 libjs-mathjax
Standards-Version: 4.7.2
Homepage: https://github.com/MatteoLacki/IsoSpec
Vcs-Browser: https://salsa.debian.org/debichem-team/isospec
Vcs-Git: https://salsa.debian.org/debichem-team/isospec.git

Package: libisospec++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libisospec++2t64 (= ${binary:Version}),
         ${misc:Depends}
Recommends: libisospec++-doc
Description: Isotopic fine structure calculator (C++ development files)
 IsoSpec implements an algorithm for fast computation of isotopologues of
 chemical substances that can alternate between joint probability and peak
 height threshold.
 .
 This package ships the development files.


Package: libisospec++2t64
Provides: ${t64:Provides}
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Replaces: libisospec++2, libisospec++1
Breaks: libisospec++2 (<< ${source:Version}), libisospec++1
Suggests: libisospec++-doc
Description: Isotopic fine structure calculator (C++ runtime)
 IsoSpec implements an algorithm for fast computation of isotopologues of
 chemical substances that can alternate between joint probability and peak
 height threshold.
 .
 This package ships the runtime shared library.


Package: python3-isospec
Architecture: any
Section: python
Depends: ${misc:Depends},
         ${shlibs:Depends},
         ${python3:Depends}
Recommends: python3-scipy, libisospec++-doc
Description: Isotopic fine structure calculator for Python 3
 IsoSpec implements an algorithm for fast computation of isotopologues of
 chemical substances that can alternate between joint probability and peak
 height threshold.
 .
 This package provides the package's Python 3 interface.


Package: libisospec++-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Isotopic fine structure calculator (C++ API documentation)
 IsoSpec implements an algorithm for fast computation of isotopologues of
 chemical substances that can alternate between joint probability and peak
 height threshold.
 .

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export LC_ALL=C.UTF-8

# For automating the d/*.links stuff.
export ISOSPEC_LIB_VERSION=2.2.3
export ISOSPEC_LIB_SOVERSION=2

export PYBUILD_NAME=isospec

export PYBUILD_SYSTEM=distutils

# Taken from CDBS file for R.
rversion	:= $(shell dpkg-query -W -f='$${Version}' r-base-dev)
rapiversion	:= $(shell dpkg-query -W -f='$${Provides}' r-base-core | grep -o 'r-api[^, ]*')

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_clean:
	rm -rf obj-x86_64-linux-gnu
	rm -rf build
	rm -f compile_commands.json
	rm -rf .pc
	rm -rf IsoSpecPy.egg-info

	# The setup.py script immediately creates that link which
	# makes the package building to stop because it finds that
	# the source tree has changed. So, first remove that link,
	# that we'll recreate when we need it later, in the
	# override_dh_auto_build target.

	rm -rf IsoSpecPy/IsoSpec++
	rm -rf .pybuild/
	rm -rf tmp-install/
	rm -rf IsoSpec++/IsoSpec++
	rm -rf IsoSpecPy/build/
	rm -rf man/html/
	rm -rf man/latex/
	rm -rf man/man/

	# Now the default target
	dh_clean

configure_python_module:
	dh_auto_configure -O--buildsystem=pybuild -O--system=distutils --sourcedirectory=.

configure_cpp_library:
	dh_auto_configure -O--buildsystem=cmake -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DISOSPEC_LIB_VERSION=$(ISOSPEC_LIB_VERSION) -DISOSPEC_LIB_SOVERSION=$(ISOSPEC_LIB_SOVERSION)

configure_cpp_library_doc:
	dh_auto_configure -O--buildsystem=cmake -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DISOSPEC_LIB_VERSION=$(ISOSPEC_LIB_VERSION) -DISOSPEC_LIB_SOVERSION=$(ISOSPEC_LIB_SOVERSION)

override_dh_auto_configure: configure_cpp_library configure_cpp_library_doc configure_python_module

build_python_module: configure_python_module
	dh_auto_build -O--buildsystem=cmake -O--system=distutils --sourcedirectory=.

build_cpp_library: configure_cpp_library
	dh_auto_build -O--buildsystem=cmake

build_cpp_library_doc: configure_cpp_library_doc
	# Generate the dev-doc in the man/hml and man/latex directories
	#doxygen man/doxyfile
	dh_auto_build -O--buildsystem=cmake -- html_doc
	# As of 20251016, pdflatex refman.tex fails.
	# dh_auto_build -O--buildsystem=cmake -- pdf_doc
	# sed-based replacement of the cloudflare URL with the MathJax.js file from the
	# libjs-mathjax package
	sh debian/replace-mathjax-cloudflare-url-local-file.sh

override_dh_auto_build: build_python_module build_cpp_library build_cpp_library_doc
	# Recreate the symlink that was created by setup.py
	# and that we had to remove at the override_dh_clean target.
	ln -sf IsoSpec++ IsoSpecPy/IsoSpec++

override_dh_auto_install: override_dh_auto_build
	# Install the Python module
	dh_auto_install -O--buildsystem=pybuild -O--system=distutils --sourcedirectory=.
	# Install the C++ library
	dh_auto_install -O--buildsystem=cmake
	# Now remove the links, that we'll provide using d/*.links
	# So that we can use libIsoSpec++.so.* in d/*.install
	rm -f debian/tmp/usr/lib/*/libIsoSpec++.so
	rm -f debian/tmp/usr/lib/*/libIsoSpec++.so.$(ISOSPEC_LIB_SOVERSION)

## isospec 2.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,24 +15,25 @@
 ############################################################
 # Basic information about project
 
-project(IsoSpec
+project(IsoSpec VERSION 2.3.1
     DESCRIPTION "A program to calculate isotopic clusters"
     HOMEPAGE_URL "https://github.com/MatteoLacki/IsoSpec")
 
-set(ISOSPEC_VERSION_MAJOR "2")
-set(ISOSPEC_VERSION_MINOR "2")
-set(ISOSPEC_VERSION_PATCH "3")
-set(ISOSPEC_LIB_NAME "libIsoSpec++")
-set(ISOSPEC_VERSION "${ISOSPEC_VERSION_MAJOR}.${ISOSPEC_VERSION_MINOR}.${ISOSPEC_VERSION_PATCH}")
-set(VERSION 2.2.3)
-set(ISOSPEC_LIB_VERSION ${ISOSPEC_VERSION})
-set(ISOSPEC_LIB_SOVERSION ${ISOSPEC_VERSION_MAJOR})
+# The call above, make these variables available:
+# ${PROJECT_NAME}_VERSION        # full version string
+# ${PROJECT_NAME}_VERSION_MAJOR
+# ${PROJECT_NAME}_VERSION_MINOR
+# ${PROJECT_NAME}_VERSION_PATCH
+
+message("Library version: ${${PROJECT_NAME}_VERSION}")
+set(${PROJECT_NAME}_LIB_SOVERSION "${${PROJECT_NAME}_VERSION_MAJOR}")
+message("Library soname: ${${PROJECT_NAME}_LIB_SOVERSION}")
 
 # Command to enable debug mode
-# cmake -DCMAKE_BUILD_TYPE=Debug 
+# cmake -DCMAKE_BUILD_TYPE=Debug
 
 
-# This setting is also typically overridden by 
+# This setting is also typically overridden by
 # configuring the build system like this:
 # cmake -DCMAKE_INSTALL_PREFIX=/usr
 # It needs to be set before include(GNUInstallDirs)
@@ -42,7 +43,7 @@
     set(CMAKE_INSTALL_PREFIX /usr)
 endif()
 
-# This module sets a number of installation directories 
+# This module sets a number of installation directories
 # according to the GNU coding standards. It takes the
 # CMAKE_INSTALL_PREFIX and then add the directories to it.
 include(GNUInstallDirs)
@@ -56,7 +57,7 @@
 #message("CMAKE_MODULE_PATH:" ${CMAKE_MODULE_PATH})
 
 # This says that when compiling, .h files must also be
-# searche in the current directory where cpp files are 
+# searche in the current directory where cpp files are
 # compiled.
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 
@@ -121,8 +122,9 @@
 # to build Win software right into GNU/Linux.
 if(MXE)
 
-    include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)
-    #include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain-olivier.cmake)
+    # Run the following cmake command line:
+    # x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../development
+    include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain-$ENV{USER}.cmake)
 
     # Set the name to the systemUname variable because in this situation that name
     # is not found, it it passed as a flag in the command line.
@@ -137,10 +139,6 @@
     if(WIN10MINGW64)
         include(${CMAKE_TOOLCHAINS_PATH}/win10-mingw64-toolchain.cmake)
     endif()
-
-elseif(APPLE)
-
-    include(${CMAKE_TOOLCHAINS_PATH}/apple-macport-toolchain.cmake)
 
 endif()
 
@@ -177,8 +175,11 @@
 message(STATUS "${BoldYellow}CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}.${ColourReset}")
 message(STATUS "${BoldYellow}CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}.${ColourReset}")
 
-
 # message(STATUS CMAKE_MODULE_PATH: ${CMAKE_MODULE_PATH})
 
-# Now actually deal with the C++ source code.
-add_subdirectory(IsoSpec++)
+# Now actually deal with the source code.
+add_subdirectory(src)
+
+# if (UNIX AND NOT APPLE)
+#   add_subdirectory(skbuild)
+# endif()

=== man/CMakeLists.txt ===

message("")
message(STATUS "${BoldGreen}Starting configuration for the doc material for ${PROJECT_NAME} ${ColourReset}")
message("")

# We want to build the documentation in the binary directory, not in the
# source directory (mind the ${CMAKE_CURRENT_BINARY_DIR}).

# Prepare the logo picture files with the right version (configure_file)
configure_file(${CMAKE_SOURCE_DIR}/CMakeStuff/isospec_logo2_high.svg.in
	${CMAKE_CURRENT_BINARY_DIR}/images/isospec_logo2_high_versioned.svg @ONLY)

configure_file(${CMAKE_SOURCE_DIR}/CMakeStuff/isospec_logo2_long.svg.in
	${CMAKE_CURRENT_BINARY_DIR}/images/isospec_logo2_long_versioned.svg @ONLY)

# Make the conversion of the svg file into a png, but only on GNU/Linux
# Produce a file with respected aspect ratio, 200 pixels wide.

if(UNIX AND NOT APPLE)

	execute_process(COMMAND gm convert -geometry 200x
		${CMAKE_CURRENT_BINARY_DIR}/images/isospec_logo2_high_versioned.svg
		${CMAKE_CURRENT_BINARY_DIR}/images/isospec_logo2_high_versioned.png)

		execute_process(COMMAND gm convert -geometry 200x
		${CMAKE_CURRENT_BINARY_DIR}/images/isospec_logo2_long_versioned.svg
		${CMAKE_CURRENT_BINARY_DIR}/images/isospec_logo2_long_versioned.png)

endif()

# Ensure that the doxyfile configuration file for Doxygen has always
# the proper version number!

configure_file(${CMAKE_SOURCE_DIR}/CMakeStuff/doxyfile.in
	${CMAKE_CURRENT_BINARY_DIR}/doxyfile @ONLY)

add_custom_target(html_doc
	COMMAND doxygen doxyfile
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
	COMMENT "Doxygen-based developer html documentation generation")

add_custom_target(pdf_doc
	COMMAND make
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/latex
	COMMENT "Doxygen-based developer pdf documentation generation")


###############
# install stuff

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/images
	DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/doc/isospec)

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
	DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/doc/isospec)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/latex/refman.pdf
  DESTINATION ${CMAKE_INSTALL_FULL_DATAROOTDIR}/doc/isospec/pdf)

# Install the man pages
install(
    DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/man/man3
    DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/
    FILES_MATCHING
    PATTERN "*.3"
)

message("")
message(STATUS "${BoldGreen}Finished configuration of the doc material.${ColourReset}")
message("")

=== src/CMakeLists.txt ===
add_subdirectory(IsoSpec++)

=== src/IsoSpec++/CMakeLists.txt ===
# CMake script for IsoSpec++ library
# Author: Filippo Rusconi
# Created: June 2020

message("\n${BoldRed}Now configuring IsoSpec++/ for ${CMAKE_PROJECT_NAME}${ColourReset}\n")


set(isospec_SRCS
	unity-build.cpp
	)

######### The shared library #########

add_library(IsoSpec++-shared SHARED ${isospec_SRCS})

message("Library version: ${${PROJECT_NAME}_VERSION}")
message("Library soname: ${${PROJECT_NAME}_LIB_SOVERSION}")

add_definitions(-fPIC)

set_target_properties(IsoSpec++-shared
	PROPERTIES OUTPUT_NAME IsoSpec++
	CLEAN_DIRECT_OUTPUT 1
	VERSION  ${${PROJECT_NAME}_VERSION}
	SOVERSION ${${PROJECT_NAME}_LIB_SOVERSION}
	)


######### The static library #########

add_library(IsoSpec++-static STATIC ${isospec_SRCS})

set_target_properties(IsoSpec++-static
	PROPERTIES OUTPUT_NAME IsoSpec++
	CLEAN_DIRECT_OUTPUT 1
	)


# Install both shared and static libs

install(TARGETS IsoSpec++-shared IsoSpec++-static
	LIBRARY NAMELINK_SKIP
	DESTINATION ${CMAKE_INSTALL_LIBDIR}
	# This one is for WIN32
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	)

# Install the header files
install(DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
    FILES_MATCHING
    PATTERN "*.h"
    PATTERN "*.hpp"
)

=== src/IsoSpec++/Makefile ===
OPTFLAGS=-O3 -march=native -mtune=native
DEBUGFLAGS=-O0 -g -Werror -DISOSPEC_DEBUG -DDEBUG -D_GLIBCXX_DEBUG
CXXFLAGS=-std=c++17 -Wall -pedantic -Wextra -Wshadow -Wcast-align -Wcast-qual -Wctor-dtor-privacy -Wdisabled-optimization -Wformat=2 -Winit-self -Wmissing-include-dirs -Wno-old-style-cast -Woverloaded-virtual -Wredundant-decls -Wshadow -Wno-sign-conversion -Wsign-promo -Wswitch-default -Wundef
SRCFILES=cwrapper.cpp allocator.cpp  dirtyAllocator.cpp  isoSpec++.cpp  isoMath.cpp  marginalTrek++.cpp  operators.cpp element_tables.cpp misc.cpp mman.cpp fixedEnvelopes.cpp fasta.cpp

all: unitylib

unitylib:
	$(CXX) $(CXXFLAGS) $(OPTFLAGS) unity-build.cpp -fPIC -shared -o libIsoSpec++.so

debug:
	$(CXX) $(CXXFLAGS) $(DEBUGFLAGS) unity-build.cpp -DDEBUG -fPIC -shared -o libIsoSpec++.so

debug-gcc:
	g++ $(CXXFLAGS) $(DEBUGFLAGS) unity-build.cpp -DDEBUG -fPIC -shared -o libIsoSpec++.so

nonunity:
	$(CXX) $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) -DDEBUG -fPIC -shared -o libIsoSpec++.so

clean:
	rm -f libIsoSpec++.so

windows:
	#g++ -O3 -std=gnu++1z -O3 -shared -static -static-libstdc++ -static-libgcc unity-build.cpp -o ../IsoSpecPy/IsoSpec++.dll
	x86_64-w64-mingw32-g++.exe -std=c++11 -O3 -shared -static -static-libstdc++ unity-build.cpp -o ../IsoSpecPy/IsoSpecPy/prebuilt-libIsoSpec++-2.1.0-x64.dll
	i686-w64-mingw32-g++.exe -std=c++11 -O3 -shared -static -static-libstdc++ unity-build.cpp -o ../IsoSpecPy/IsoSpecPy/prebuilt-libIsoSpec++-2.1.0-x32.dll
check:
	cpplint *.cpp *.h
	#cppcheck --std=c++11 --language=c++ --enable=style,portability,missingInclude,performance -q --force *.cpp *.h --suppress=memleakOnRealloc:*:* --inline-suppr --template={file}:{line}\ \({severity}\)\ \<{id}\>:\ {message}

check11:
	$(CXX) -std=c++11 -Wall -pedantic -Wextra -Wshadow -fsyntax-only unity-build.cpp

asm:
	$(CXX) $(CXXFLAGS) $(OPTFLAGS) unity-build.cpp -S -o out.S

=== src/IsoSpecR/DESCRIPTION ===
Encoding: UTF-8
Package: IsoSpecR
Type: Package
Title: The IsoSpec Algorithm
Version: 2.3.0
Date: 2025-10-25
Authors@R: c(person(given = c("Mateusz", "Krzysztof"),
                      family = "Łącki",
                      role = c("cre", "aut"),
                      email = "matteo.lacki@gmail.com",
                      comment = c(ORCID = "0000-0001-7415-4748")),
               person(given = c("Michał", "Piotr"),
                      family = "Startek",
                      role = "aut",
                      comment = c(ORCID = "0000-0001-5227-3447"))
               )
Maintainer: Matteo Lacki <matteo.lacki@gmail.com>
Description: IsoSpec is a fine structure calculator used for obtaining the most
    probable masses of a chemical compound given the frequencies of the composing
    isotopes and their masses. It finds the smallest set of isotopologues with
    a given probability. The probability is assumed to be that of the product of
    multinomial distributions, each corresponding to one particular element and
    parametrized by the frequencies of finding these elements in nature. These
    numbers are supplied by IUPAC - the International Union of Pure and Applied
    Chemistry. See: Lacki, Valkenborg, Startek (2020) <DOI:10.1021/acs.analchem.0c00959>
    and Lacki, Startek, Valkenborg, Gambin (2017) <DOI:10.1021/acs.analchem.6b01459>
    for the description of the algorithms used.
License: BSD_2_clause + file LICENCE
URL: http://matteolacki.github.io/IsoSpec/
Depends:
    R (>= 3.0.0)
Imports:
    Rcpp (>= 0.12.0)
Suggests:
    testthat
LazyData: no
LinkingTo: Rcpp
NeedsCompilation: yes
SystemRequirements: C++17
RoxygenNote: 7.1.1

=== tests/C++/Makefile ===
CXX=clang++
OPTFLAGS=-O3 -march=native -mtune=native -g
DEBUGFLAGS=-O0 -g -DISOSPEC_DEBUG -DDEBUG -D_GLIBCXX_DEBUG
TESTFLAGS=-fsanitize=leak,undefined
TESTMEMFLAGS= $(TESTFLAGS) -fsanitize=memory
TESTADDRFLAGS= $(TESTFLAGS) -fsanitize=address
LLVMTESTFLAGS= -fsanitize=dataflow,cfi,safe-stack
CXXFLAGS=-std=c++17 -Wall -I../../IsoSpec++ -Wextra -pedantic
SRCFILES=../../IsoSpec++/unity-build.cpp

all: main_test cmdlines

main_test:
	clang++ $(CXXFLAGS) $(OPTFLAGS) main_test.cpp -o main_test_clang
	g++ $(CXXFLAGS) $(OPTFLAGS) main_test.cpp -o main_test_gcc
	g++ $(CXXFLAGS) $(DEBUGFLAGS) main_test.cpp -o main_test_dbg
	g++ $(CXXFLAGS) $(DEBUGFLAGS) main_test.cpp -DISOSPEC_SKIP_SLOW_TESTS -o main_test_dbg_fast
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) main_test.cpp -DISOSPEC_SKIP_SLOW_TESTS -fsanitize=address,undefined -o main_test_asan
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) main_test.cpp -fsanitize=cfi -flto -fvisibility=hidden -o main_test_cfi
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) main_test.cpp -fsanitize=safe-stack -o main_test_ss
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) main_test.cpp -DISOSPEC_TESTS_MEMSAN -fsanitize=memory,undefined -o main_test_memsan

cmdlines: formula_layered formula_layered_generator formula_ordered formula_threshold formula_threshold_simple formula_threshold_profile mass_range formula_stochastic

formula_ordered:
	clang++ $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) from_formula_ordered.cpp -o ./from_formula_ordered_clang
	g++ $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) from_formula_ordered.cpp -o ./from_formula_ordered_gcc
	g++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_ordered.cpp -o ./from_formula_ordered_dbg
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_ordered.cpp -fsanitize=address,undefined -o ./from_formula_ordered_asan
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_ordered.cpp -DISOSPEC_TESTS_MEMSAN -fsanitize=memory,undefined -o ./from_formula_ordered_memsan

formula_threshold_simple:
	clang++  $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) from_formula_threshold_simple.cpp -o ./from_formula_threshold_simple_clang
	g++ $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) from_formula_threshold_simple.cpp -o ./from_formula_threshold_simple_gcc
	g++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_threshold_simple.cpp -o ./from_formula_threshold_simple_dbg
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_threshold_simple.cpp -fsanitize=address,undefined -o ./from_formula_threshold_simple_asan
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_threshold_simple.cpp -DISOSPEC_TESTS_MEMSAN -fsanitize=memory,undefined -o ./from_formula_threshold_simple_memsan

formula_threshold:
	clang++  $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) from_formula_threshold.cpp -o ./from_formula_threshold_clang
	g++ $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) from_formula_threshold.cpp -o ./from_formula_threshold_gcc
	g++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_threshold.cpp -o ./from_formula_threshold_dbg
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_threshold.cpp -fsanitize=address,undefined -o ./from_formula_threshold_asan
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_threshold.cpp -DISOSPEC_TESTS_MEMSAN -fsanitize=memory,undefined -o ./from_formula_threshold_memsan

formula_threshold_profile:
	clang++  $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) from_formula_threshold_profile.cpp -g -pg -o ./from_formula_threshold_gprof_clang
	g++ $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) from_formula_threshold_profile.cpp -g -pg -o ./from_formula_threshold_gprof_gcc
	clang++  $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) from_formula_threshold_profile.cpp -g -o ./from_formula_threshold_profile_clang
	g++ $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) from_formula_threshold_profile.cpp -g -o ./from_formula_threshold_profile_gcc

formula_stochastic:
	clang++  $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) from_formula_stochastic.cpp -o ./from_formula_stochastic_clang
	g++ $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) from_formula_stochastic.cpp -o ./from_formula_stochastic_gcc
	g++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_stochastic.cpp -o ./from_formula_stochastic_dbg
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_stochastic.cpp -fsanitize=address,undefined -o ./from_formula_stochastic_asan
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_stochastic.cpp -DISOSPEC_TESTS_MEMSAN -fsanitize=memory,undefined -o ./from_formula_stochastic_memsan

formula_layered:
	clang++  $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) from_formula_layered.cpp -o ./from_formula_layered_clang
	g++ $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) from_formula_layered.cpp -o ./from_formula_layered_gcc
	g++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_layered.cpp -o ./from_formula_layered_dbg
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_layered.cpp -fsanitize=address,undefined -o ./from_formula_layered_asan
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_layered.cpp -DISOSPEC_TESTS_MEMSAN -fsanitize=memory,undefined -o ./from_formula_layered_memsan

formula_layered_generator:
	clang++  $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) from_formula_layered_generator.cpp -o ./from_formula_layered_generator_clang
	g++ $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) from_formula_layered_generator.cpp -o ./from_formula_layered_generator_gcc
	g++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_layered_generator.cpp -o ./from_formula_layered_generator_dbg
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_layered_generator.cpp -fsanitize=address,undefined -o ./from_formula_layered_generator_asan
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) from_formula_layered_generator.cpp -DISOSPEC_TESTS_MEMSAN -fsanitize=memory,undefined -o ./from_formula_layered_generator_memsan

mass_range:
	clang++  $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) mass_range.cpp -o ./mass_range_clang
	g++ $(CXXFLAGS) $(OPTFLAGS) $(SRCFILES) mass_range.cpp -o ./mass_range_gcc
	g++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) mass_range.cpp -o ./mass_range_dbg
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) mass_range.cpp -fsanitize=address,undefined -o ./mass_range_asan
	clang++ $(CXXFLAGS) $(DEBUGFLAGS) $(SRCFILES) mass_range.cpp -DISOSPEC_TESTS_MEMSAN -fsanitize=memory,undefined -o ./mass_range_memsan


ti:
	$(CXX) $(CXXFLAGS) $(OPTFLAGS) ../../IsoSpec++/unity-build.cpp titin-test.cpp -o ./titin

mr:
	$(CXX) $(CXXFLAGS) $(DEBUGFLAGS) marginal-test.cpp -o marginal -g

tabulator:
	clang++ -std=c++11 tabulator_test.cpp -o tabulator

la:
	$(CXX) $(CXXFLAGS) $(DEBUGFLAGS) ../../IsoSpec++/unity-build.cpp layered-test.cpp -o layered

IsoThresholdGenerator:
	clang++ -std=c++11 IsoThresholdGenerator.cpp -o IsoThresholdGenerator -lpthread

nr_conf:
	clang++ -std=c++11 nr_conf.cpp -o nr_conf -lpthread

clean:
	rm -rf *_gcc *_clang *_dbg *_memsan *_asan IsoThresholdGenerator layered main_test_cfi main_test_ss marginal nr_conf tabulator titin *.dSYM a.out from_formula_layered_clang_more main_test_dbg_fast

=== debian/changelog ===
isospec (2.3.1-2) unstable; urgency=medium

  * Fix missing dh_quilt_patch at configure target. Odd because in my
    chroot the package builds fine.

  * libisospec++-dev: Drop Multi-Arch: same (Janitor pull request).

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 29 Oct 2025 12:32:42 +0100

isospec (2.3.1-1) unstable; urgency=medium

  * New upstream release with source configuration and Debian packaging
    worked alongside upstream (thank you michalsta !).

  * Disabled production of the refman.pdf file due to bug in Doxygen
    (Closes: #1114157).

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 22 Oct 2025 21:06:59 +0200

isospec (2.2.3+cleaned2-1) UNRELEASED; urgency=medium

  * Disabled production of the refman.pdf file due to bug in Doxygen
    (Closes: #1114157) and synchronize the git repos.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 22 Oct 2025 12:14:20 +0200

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
 Uploaders: Filippo Rusconi <lopippo@debian.org>
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
+ quilt,
  dh-exec,
  graphicsmagick-imagemagick-compat,
  cmake,
@@ -11,7 +12,9 @@
  dh-python,
  python3-dev,
  python3-setuptools,
+ pybuild-plugin-pyproject,
  python3-cffi,
+ python3-scikit-build-core,
  texlive-latex-base,
  texlive-latex-recommended,
  texlive-latex-extra,
@@ -22,6 +25,7 @@
  doxygen,
  libjs-mathjax
 Standards-Version: 4.7.2
+Rules-Requires-Root: no
 Homepage: https://github.com/MatteoLacki/IsoSpec
 Vcs-Browser: https://salsa.debian.org/debichem-team/isospec
 Vcs-Git: https://salsa.debian.org/debichem-team/isospec.git
@@ -29,7 +33,6 @@
 Package: libisospec++-dev
 Section: libdevel
 Architecture: any
-Multi-Arch: same
 Depends: libisospec++2t64 (= ${binary:Version}),
          ${misc:Depends}
 Recommends: libisospec++-doc

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export LC_ALL=C.UTF-8

# For automating the d/*.links stuff.
export ISOSPEC_LIB_VERSION=$(DEB_VERSION_UPSTREAM)
export ISOSPEC_LIB_SOVERSION=2

export PYBUILD_NAME=isospec

export PYBUILD_SYSTEM=pyproject


# Taken from CDBS file for R.
rversion	:= $(shell dpkg-query -W -f='$${Version}' r-base-dev)
rapiversion	:= $(shell dpkg-query -W -f='$${Provides}' r-base-core | grep -o 'r-api[^, ]*')

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_clean:
	dh_quilt_unpatch
	rm -rf obj-$(DEB_HOST_MULTIARCH)
	rm -rf build
	rm -f compile_commands.json
	rm -rf .pc
	rm -rf IsoSpecPy.egg-info
	rm -rf .pybuild/
	rm -rf tmp-install/
	rm -rf IsoSpec++/IsoSpec++
	rm -rf IsoSpecPy/build/

	# Now the default target
	dh_clean

configure_cpp_library:
	dh_auto_configure -O--buildsystem=cmake  --sourcedirectory=./src/IsoSpec++ -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DISOSPEC_LIB_VERSION=$(ISOSPEC_LIB_VERSION) -DISOSPEC_LIB_SOVERSION=$(ISOSPEC_LIB_SOVERSION)

configure_python_module:
	dh_auto_configure -O--buildsystem=pybuild -O--system=distutils --sourcedirectory=./src/IsoSpecPy

configure_cpp_library_doc:
	dh_auto_configure -O--buildsystem=cmake -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DISOSPEC_LIB_VERSION=$(ISOSPEC_LIB_VERSION) -DISOSPEC_LIB_SOVERSION=$(ISOSPEC_LIB_SOVERSION)

override_dh_auto_configure:
	dh_quilt_patch
	dh_auto_configure -O--buildsystem=cmake -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DISOSPEC_LIB_VERSION=$(ISOSPEC_LIB_VERSION) -DISOSPEC_LIB_SOVERSION=$(ISOSPEC_LIB_SOVERSION)

override_dh_auto_build:
	# The C++ lib
	dh_auto_build -O--buildsystem=cmake
	# The Python module
	dh_auto_build --buildsystem=pybuild
	# The Doxygen-based HTML format documentation
	dh_auto_build -O--buildsystem=cmake -- html_doc
	# The Doxygen-based PDF format documentation
	# As of 20251016, pdflatex refman.tex fails.
	# dh_auto_build -O--buildsystem=cmake -- pdf_doc

	# sed-based replacement of the cloudflare URL with the MathJax.js file from the
	# libjs-mathjax package
	sh debian/replace-mathjax-cloudflare-url-local-file.sh

override_dh_auto_install:
	# The C++ lib
	dh_auto_install -O--buildsystem=cmake
	# The Python module
	dh_auto_install -O--buildsystem=pybuild
	# Now remove the links, that we'll provide using d/*.links
	# So that we can use libIsoSpec++.so.* in d/*.install
	rm -f debian/tmp/usr/lib/*/libIsoSpec++.so
	rm -f debian/tmp/usr/lib/*/libIsoSpec++.so.$(ISOSPEC_LIB_SOVERSION)

=== debian/watch ===
version=4

opts="repack, \
			repacksuffix=+dfsg1, \
			compression=gzip, \
			dversionmangle=s/\+dfsg\d*$//, \
			filenamemangle=s/\S+\/v([\d\.]*)\.tar\.gz/isospec-$1\.tar\.gz/" \
			https://github.com/MatteoLacki/IsoSpec/releases/ \
			/MatteoLacki/IsoSpec/archive/v([\d\.]*)\.tar\.gz \
			debian \
			uupdate
# Web page
#https://github.com/MatteoLacki/IsoSpec/releases

# The link to the source tarball as when clicking (see below)
#https://github.com/MatteoLacki/IsoSpec/archive/v2.0.2.tar.gz

# The http href code that links to the source tarball in the Web page above
# <a class="muted-link" href="/MatteoLacki/IsoSpec/archive/v2.0.2.tar.gz" rel="nofollow">

## isospec 2.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 ############################################################
 # Basic information about project
 
-project(IsoSpec VERSION 2.3.1
+project(IsoSpec VERSION 2.3.2
     DESCRIPTION "A program to calculate isotopic clusters"
     HOMEPAGE_URL "https://github.com/MatteoLacki/IsoSpec")

=== Makefile ===
# This Makefile is not meant for end-users, only as a convenience for developers. Do not touch.
reinstall: clean
	pip uninstall -y IsoSpecPy ; pip uninstall -y IsoSpecPy ; pip uninstall -y IsoSpecPy || true
	python setup.py install --user

reinstallall: reinstall2 reinstall3
rea: reinstallall

reinstall2: clean
	pip2 uninstall -y IsoSpecPy ; pip2 uninstall -y IsoSpecPy ; pip2 uninstall -y IsoSpecPy || true
	python2 setup.py install --user
reinstall3: clean
	pip3 uninstall -y IsoSpecPy ; pip3 uninstall -y IsoSpecPy ; pip3 uninstall -y IsoSpecPy || true
	python3 setup.py install --user
clean:
	rm -rf IsoSpecPy.egg-info build dist
twine: clean
	python setup.py sdist
	twine upload dist/*

=== man/CMakeLists.txt ===
--- 
+++ 
@@ -18,13 +18,13 @@
 
 if(UNIX AND NOT APPLE)
 
-	execute_process(COMMAND gm convert -geometry 200x
-		${CMAKE_CURRENT_BINARY_DIR}/images/isospec_logo2_high_versioned.svg
-		${CMAKE_CURRENT_BINARY_DIR}/images/isospec_logo2_high_versioned.png)
+  execute_process(COMMAND rsvg-convert -w 200 -f png -o
+    ${CMAKE_CURRENT_BINARY_DIR}/images/isospec_logo2_high_versioned.png
+    ${CMAKE_CURRENT_BINARY_DIR}/images/isospec_logo2_high_versioned.svg)
 
-		execute_process(COMMAND gm convert -geometry 200x
-		${CMAKE_CURRENT_BINARY_DIR}/images/isospec_logo2_long_versioned.svg
-		${CMAKE_CURRENT_BINARY_DIR}/images/isospec_logo2_long_versioned.png)
+		execute_process(COMMAND rsvg-convert -w 200 -f png -o
+		${CMAKE_CURRENT_BINARY_DIR}/images/isospec_logo2_long_versioned.png
+		${CMAKE_CURRENT_BINARY_DIR}/images/isospec_logo2_long_versioned.svg)
 
 endif()

=== skbuild/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

project(IsoSpecPy CXX)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

#find_package(PythonExtensions REQUIRED)
#find_package(Python COMPONENTS Interpreter Development REQUIRED)

add_library(IsoSpecCppPy SHARED ../src/IsoSpec++/unity-build.cpp)
target_compile_features(IsoSpecCppPy PRIVATE cxx_std_17)
#python_extension_module(IsoSpecCppPy)
install(TARGETS IsoSpecCppPy LIBRARY DESTINATION IsoSpecPy)
install(DIRECTORY ../src/IsoSpec++/ DESTINATION IsoSpecPy/IsoSpec++
        FILES_MATCHING PATTERN "*.h" PATTERN "*.hpp" PATTERN "*.hxx"
)

=== debian/changelog ===
isospec (2.3.2-2) unstable; urgency=medium

  * Team Upload
  * python3-isospec: add a runtime dependency on python3-cffi
  * Drop "Rules-Requires-Root: no": it is the default now
  * Bump Standards-Version to 4.7.3 drop Priority: tag
  * Use dh-sequence-python3
  * Drop empty patch

 -- Alexandre Detiste <tchet@debian.org>  Sat, 28 Feb 2026 18:14:05 +0100

isospec (2.3.2-1) unstable; urgency=medium

  * New upstream release.

  * Steer away from graphicsmagick and replace by librsvg2-bin for
    conversion of svg to png.

  * libisospec++-dev: Drop Multi-Arch: same (Janitor pull request).

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 05 Nov 2025 23:00:09 +0100

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,15 @@
 Source: isospec
 Section: science
-Priority: optional
 Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
 Uploaders: Filippo Rusconi <lopippo@debian.org>
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
  quilt,
  dh-exec,
- graphicsmagick-imagemagick-compat,
+# To export from svg to png
+ librsvg2-bin,
  cmake,
  d-shlibs,
- dh-python,
+ dh-sequence-python3,
  python3-dev,
  python3-setuptools,
  pybuild-plugin-pyproject,
@@ -24,8 +24,7 @@
  ghostscript,
  doxygen,
  libjs-mathjax
-Standards-Version: 4.7.2
-Rules-Requires-Root: no
+Standards-Version: 4.7.3
 Homepage: https://github.com/MatteoLacki/IsoSpec
 Vcs-Browser: https://salsa.debian.org/debichem-team/isospec
 Vcs-Git: https://salsa.debian.org/debichem-team/isospec.git
@@ -65,9 +64,11 @@
 Package: python3-isospec
 Architecture: any
 Section: python
-Depends: ${misc:Depends},
-         ${shlibs:Depends},
-         ${python3:Depends}
+Depends:
+ python3-cffi,
+ ${misc:Depends},
+ ${shlibs:Depends},
+ ${python3:Depends},
 Recommends: python3-scipy, libisospec++-doc
 Description: Isotopic fine structure calculator for Python 3
  IsoSpec implements an algorithm for fast computation of isotopologues of

=== debian/rules ===
--- 
+++ 
@@ -27,7 +27,7 @@
 rapiversion	:= $(shell dpkg-query -W -f='$${Provides}' r-base-core | grep -o 'r-api[^, ]*')
 
 %:
-	dh $@ --with python3 --buildsystem=pybuild
+	dh $@ --buildsystem=pybuild
 
 override_dh_clean:
 	dh_quilt_unpatch
